{{HexWalker (c) copyright 2010 David Dorhout  All right reserved.  No portion of this code may be used
without prior written approvial from David Dorhout  vanmunch@yahoo.com
}}

CON

_CLKMODE         = XTAL1 + PLL16X
_XINFREQ         = 5_000_000


'Constants for using the Propeller Servo Control (PSC) boards    
COMPIN           = 23               'Pin used for communication with the PSC
PSC_BAUD         = 0                'Baud rate (0 - 2400, 1 - 38400)
Ramp             = 0               'Ramp is the speed between 0-63 that the PSC turns the servos  (fast to slow)



'Constants for the leg servos
RPawFoot        = 31
RPawKnee        = 30
RPawHip         = 29

RFFoot          = 26
RFKnee          = 27
RFHip           = 28

RRFoot          = 23
RRKnee          = 22
RRHip           = 21

LPawFoot        =  0
LPawKnee        =  1
LPawHip         =  2

LFFoot          = 15
LFKnee          = 14
LFHip           = 13

LRFoot          =  3
LRKnee          =  4
LRHip           =  5

'The maximune height that the knees can go up
KneeHightMax    =  1000

'The maximune height that the three down legs can go in an attempt to raise
'the body over an obstical
BodyHeightMax   =  510

'Toe Sensor Pins
RPawToeSensor   =  0
RFToeSensor     =  1
RRToeSensor     =  2
LPawToeSensor   =  3
LFToeSensor     =  4
LRToeSensor     =  5


VAR
'Ping))) variables
Long                  range            'Distance for Ping)))
Long                  PingServoD       'Direction/PW of the servo holding the Ping)))
Long                  PingServoR
Long                  PingServoL
Long                  DirectionPW

'Variables for the PW of each leg servo
Long                  RPawFootPW        
Long                  RPawKneePW        
Long                  RPawHipPW         

Long                  RFFootPW          
Long                  RFKneePW          
Long                  RFHipPW           

Long                  RRFootPW          
Long                  RRKneePW          
Long                  RRHipPW           

Long                  LPawFootPW        
Long                  LPawKneePW        
Long                  LPawHipPW         

Long                  LFFootPW          
Long                  LFKneePW          
Long                  LFHipPW           

Long                  LRFootPW          
Long                  LRKneePW          
Long                  LRHipPW            

Long                  RPawFtSign
Long                  RFFtSign
Long                  RRFtSign

Long                  PW

'long    Problem1
'long    Problem2
'long    Problem3
'long    CogNumber

'long  stack[200]                     'Cog stack space
'byte  cog                            'Cog ID

'long    leg


'Variables for Leg Placement
long                  toeX
long                  toeY
long                  toeZ

Long                  HipX
Long                  HipY  
Long                  HipZ

Long                  KneeX
Long                  KneeY  
Long                  KneeZ

Long                  FootX
Long                  FootY
Long                  FootZ 

long                  toeA
long                  toeB
long                  toeC

Long                  HipA
Long                  HipB  
Long                  HipC

Long                  KneeA
Long                  KneeB  
Long                  KneeC

Long                  FootA
Long                  FootB
Long                  FootC 


Long                  KneeXPW
Long                  KneeYPW
Long                  KneeZPW

Long                  LegStateX
Long                  LegStateY 
Long                  LegStateZ 
Long                  LegStateXYZ

Long                  DirectionX
Long                  DirectionY
Long                  DirectionZ

Long                  StartX
Long                  StartY
Long                  StartZ

Long                  FinishX
Long                  FinishY
Long                  FinishZ

Long                  ToeSensorX
Long                  ToeSensorY
Long                  ToeSensorZ

Long                  HipXPlacement
Long                  HipYPlacement
Long                  HipZPlacement


Long                  BodyHeight
Long                  StuckLegHip
Long                  StuckLegHipStart
Long                  StuckLegHipFinish
Long                  StuckLegKnee
Long                  StuckLegFoot
Long                  StuckLegToeSensor
Long                  StuckLegDirection


OBJ
     PSC   : "ServoControllerSerial"
   ' ping   : "ping"
   Debug   : "FullDuplexSerialPlus"
   'fmath   : "FloatMath"
   'Fstring : "FloatString"



PUB StartUp
''Starts up and Initializes leg values from 0 to 750
    waitcnt(clkfreq*5 + cnt)
    
    PSC.START(COMPIN, PSC_BAUD) 
    Debug.Start(31, 30, 0, 57600)
    Debug.tx(Debug#CLS) 
    Debug.str(string(13, "Starting! :) "))
    Debug.str(string(13, "Initializing leg values! :) "))

    RPawFootPW     := 750   
    RPawKneePW     := 750   
    RPawHipPW      := 750   

    RFFootPW       := 750   
    RFKneePW       := 750   
    RFHipPW        := 750   

    RRFootPW       := 750   
    RRKneePW       := 750   
    RRHipPW        := 750   

    LPawFootPW     := 750   
    LPawKneePW     := 750   
    LPawHipPW      := 750   

    LFFootPW       := 750   
    LFKneePW       := 750   
    LFHipPW        := 750   

    LRFootPW       := 750   
    LRKneePW       := 750   
    LRHipPW        := 750

    HipX           := 750
    HipY           := 750
    HipZ           := 750

    KneeX          := 750
    KneeY          := 750
    KneeZ          := 750

    KneeXPW        := 750
    KneeYPW        := 750
    KneeZPW        := 750

    HipXPlacement  := 750
    HipYPlacement  := 750
    HipZPlacement  := 750

    BodyHeight     := 750

    waitcnt(clkfreq*1 + cnt)
    LegSetUp
    
PUB LegSetUp
    Debug.str(string(13, "LegSetUp! :) ")) 

    StartX  := 750
    FinishX := 600
    HipXPlacement := StartX

    StartY  := 750
    FinishY := 750
    HipYPlacement := StartY

    StartZ  := 750
    FinishZ := 950
    HipZPlacement := StartZ

    HipX  := RPawHip
    KneeX := RPawKnee
    FootX := RPawFoot
    toeX  := RPawToeSensor

    HipY  := LFHip
    KneeY := LFKnee
    FootY := LFFoot
    toeY  := LFToeSensor
    
    HipZ  := RRHip
    KneeZ := RRKnee
    FootZ := RRFoot
    toeZ  := RRToeSensor

    HipA  := LPawHip
    KneeA := LPawKnee
    FootA := LPawFoot
    toeA  := LPawToeSensor

    HipB  := RFHip
    KneeB := RFKnee
    FootB := RFFoot
    toeB  := RFToeSensor
    
    HipC  := LRHip
    KneeC := LRKnee
    FootC := LRFoot
    toeC  := LRToeSensor


''Caculating if you need to add, subtract or do nothing with moving the hip from
''it's starting position
    If StartX == FinishX
       DirectionX := 0
       LegStateX  := 1
    ELSEIf StartX => FinishX
       DirectionX := -1
    ELSEIf StartX =< FinishX
       DirectionX := 1

    If StartY == FinishY
       DirectionY := 0
       LegStateY  := 1
    ElseIf StartY => FinishY
       DirectionY := -1
    ElseIf StartY =< FinishY
       DirectionY := 1

    If StartZ == FinishZ
       DirectionZ := 0
       LegStateZ  := 1
    ElseIf StartZ => FinishZ
       DirectionZ := -1
    ElseIf StartZ =< FinishZ
       DirectionZ := 1

    
    
    MoveHipsXYZ


PUB MoveHipsXYZ 
    Debug.str(string(13, "MoveHipsXYZ! :) "))
    Debug.Bin(ina[0..5], 6)                           ''Displays the state of the 6 leg touch
                                                      ''sensors.  A "1" means that it's touching

    Debug.str(string(13, "LegStateX "))
    Debug.dec(LegStateX)
    Debug.str(string(13, "LegStateY "))
    Debug.dec(LegStateY)
    Debug.str(string(13, "LegStateZ "))
    Debug.dec(LegStateZ)
    Debug.str(string(13, "LegStateXYZ "))
    Debug.dec(LegStateXYZ)

    LegStateXYZ := LegStateX + LegStateY + LegStateZ
    If LegStateXYZ == 3
       Debug.str(string(13, "Hips XY&Z are in place; now going to lower feetXY&Z! :) ")) 
       LowerFeetXYZ
    
                                                      
    MoveHipX
    
PUB MoveHipX
    Debug.str(string(13, "MoveHipX"))
    
    If HipXPlacement == FinishX
       LegStateX  := 1
       Debug.str(string(13, "Hip X is done moving; skipping X to MoveHipsY! :) "))
       MoveHipY

    HipXPlacement := HipXPlacement + DirectionX*2
    PSC.SETPOS(HipX, Ramp, HipXPlacement)
    'waitcnt(clkfreq/10 + cnt)
    
    ''This section checks to see if the Toe sensor is touching something and if it is,
    ''pulls the hip back a bit and raises the leg
    If ina[toeX] == 1
      Debug.str(string(13, "Leg/pin toeX (RPawToeSensor) touching!!! :) "))
      HipXPlacement := HipXPlacement + (DirectionX* -10)
      KneeXPW := KneeXPW + 30
      KneeXPW <#= KneeHightMax
      Debug.str(string(13, "KneeXPW "))
      Debug.dec(KneeXPW) 
      waitcnt(clkfreq/10 + cnt)

      IF KneeXPW => KneeHightMax           
        
           Debug.str(string(13, "KneeHightMax reached, going to hook leg "))
          'Brings stuck foot to starting place
           PSC.SETPOS(HipX, Ramp, StartX)       
           PSC.SETPOS(KneeX, Ramp, 1100)
           PSC.SETPOS(FootX, Ramp, 800)  
           waitcnt(clkfreq/1 + cnt)
          repeat
           If ina[toeX] == 1
              Debug.str(string(13, "Leg/pin toeX (RPawToeSensor) touching again "))
              Debug.str(string(13, "Going to Raise body "))
              'RaiseBody
              ''lifts body up so that foot or hip can go over or on top of an object
              Debug.str(string(13, "RaiseBody"))   

              BodyHeight := BodyHeight - 30     
              Debug.str(string(13, "BodyHeight"))
              Debug.dec(BodyHeight)
     
              If BodyHeight =< BodyHeightMax
                 Debug.str(string(13, "BackUpAndChangeApproach")) 'Going to try and bring leg back and try to hook it over"))         
                 BackUpAndChangeApproach 'HookLegOver
              ELSE
                 Debug.str(string(13, "Raising Body"))
                 PSC.SETPOS(KneeA, Ramp, BodyHeight)
                 PSC.SETPOS(KneeB, Ramp, BodyHeight)
                 PSC.SETPOS(KneeC, Ramp, BodyHeight)

                 PSC.SETPOS(FootA, Ramp, BodyHeight)
                 PSC.SETPOS(FootB, Ramp, BodyHeight)
                 PSC.SETPOS(FootC, Ramp, BodyHeight)  
                'MoveHipX
                                
              HipXPlacement := HipXPlacement + DirectionX*2
              PSC.SETPOS(HipX, Ramp, HipXPlacement)

              If HipXPlacement == FinishX
                 LegStateX  := 1
                 Debug.str(string(13, "Hip X is done moving; skipping X to MoveHipsY! :) "))
                 MoveHipY
              
         
      'Moves leg back and up
      PSC.SETPOS(HipX, Ramp, HipXPlacement)       
      PSC.SETPOS(KneeX, Ramp, KneeXPW)
      PSC.SETPOS(FootX, Ramp, KneeXPW)  
      'waitcnt(clkfreq/10 + cnt)

    MoveHipY

    
  '  if ina[LFToeSensor] == 1
  '    Debug.str(string(13, "Leg/pin LFToeSensor touching!!! :) "))
 
PUB MoveHipY 
    Debug.str(string(13, "MoveHipY"))


    

    MoveHipZ
    
PUB MoveHipZ 
    Debug.str(string(13, "MoveHipZ"))
    'waitcnt(clkfreq/1 + cnt)


    
    MoveHipsXYZ
PUB  RaiseBody
''lifts body up so that foot or hip can go over or on top of an object
     Debug.str(string(13, "RaiseBody"))   

     BodyHeight := BodyHeight - 30     
     Debug.str(string(13, "BodyHeight"))
     Debug.dec(BodyHeight)
     
     If BodyHeight =< BodyHeightMax
         Debug.str(string(13, "BackUpAndChangeApproach")) 'Going to try and bring leg back and try to hook it over"))         
         BackUpAndChangeApproach 'HookLegOver
     ELSE
         Debug.str(string(13, "Raising Body"))
         PSC.SETPOS(KneeA, Ramp, BodyHeight)
         PSC.SETPOS(KneeB, Ramp, BodyHeight)
         PSC.SETPOS(KneeC, Ramp, BodyHeight)

         PSC.SETPOS(FootA, Ramp, BodyHeight)
         PSC.SETPOS(FootB, Ramp, BodyHeight)
         PSC.SETPOS(FootC, Ramp, BodyHeight)  
 
       MoveHipX
     

PUB  LowerBody
''Lowers body so that it's not so tall, goes back to normal height
     Debug.str(string(13, "LowerBody"))   





PUB LowerFeetXYZ
''Lowers feet until they touch something
    Debug.str(string(13, "LowerFeetXYZ")) 





PUB HookLegOver | StuckKneePW, StuckFootPW
'' Robot brings leg back to the start location and trys to hook it over the obstical
'' Last ditch attempt before going in a differnt direction

 'Brings hip back to starting point with foot and knee at Max, then trys to go to go to Finish
 'with bringing foot up (lower PWs) to avoide obsticals while checking to see if foot is touching
 'something
    Debug.str(string(13, "HookLegOver"))

    StuckKneePW := 1100
    StuckFootPW := KneeHightMax
    
    'Brings stuck foot to starting place
    PSC.SETPOS(StuckLegHip, Ramp, StartX)       
    PSC.SETPOS(StuckLegKnee, Ramp, StuckKneePW)
    PSC.SETPOS(StuckLegFoot, Ramp, StuckFootPW)  
    waitcnt(clkfreq/1 + cnt)

     IF LegStateX
     
     StuckLegHip := StuckLegHip + StuckLegDirection

          'Records the "Stuck" legs variables in case the program needs to go to "Hook leg over"
           StuckLegHip          := HipX
           StuckLegKnee         := KneeX
           StuckLegFoot         := FootX
           StuckLegHipStart     := StartX
           StuckLegHipFinish    := FinishX
           StuckLegToeSensor    := ToeX
           StuckLegDirection    := DirectionX
           'StuckLegState        := LegStateX
      

'            StuckLegToeSensor
'           StuckLegHip          := HipX
'           StuckLegHipStart     := StartX
'           StuckLegHipFinish    := FinishX
    






PUB BackUpAndChangeApproach
'' Robot backs up a little and trys again
    Debug.str(string(13, "BackUpAndChangeApproach")) 

   waitcnt(clkfreq*1 + cnt)


   
{{ 

    Debug.str(string(13, "StartZ"))
    Debug.dec(StartZ)
    Debug.str(string(13, "FinishZ"))
    Debug.dec(FinishZ)


    
   repeat
    if placment1 > End1
     placment1 := Start1 + 1
     Start1 := placment1   
     PSC.SETPOS(LFHip, Ramp, placment1)

   ' if placment2 > End2
   ' placment2 := Start1 - 1
   'Start2 := placment2   
   'PSC.SETPOS(LRHip, Ramp, placment2)
}}



    'waitcnt(clkfreq/10 + cnt)
    'waitcnt(clkfreq*1 + cnt)
    'PW := 800
    'PSC.SETPOS(leg, Ramp, PW)
    'waitcnt(clkfreq*1 + cnt)